/*
 * This file is part of activationd.
 *
 * Copyright © 2019 Samsung Electronics
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef EPC_ACTION_H
#define EPC_ACTION_H

#include "common.h"

#define EPC_ACTION_SERVICE_RESTART_ID "org.tizen.epc.action.SERVICE_RESTART"
#define EPC_ACTION_SERVICE_RECOVER_ID "org.tizen.epc.action.SERVICE_RECOVER"
#define EPC_ACTION_REBOOT_ID "org.tizen.epc.action.REBOOT"
#define EPC_ACTION_RECOVERY_REBOOT_ID "org.tizen.epc.action.RECOVERY_REBOOT"
#define EPC_ACTION_UNIT_START_ID "org.tizen.epc.action.UNIT_START"
#define EPC_ACTION_DBUS_SIGNAL_FORWARD_ID "org.tizen.epc.action.DBUS_SIGNAL_FORWARD"

#define EPC_DEFAULT_ACTION_IMPL "default"

#define EPC_AD_SERVICE_NAME "ServiceName"
#define EPC_AD_CLEANUP_UNIT "RecoveryUnit"
#define EPC_AD_UNIT_NAME "UnitName"
#define EPC_AD_UNIT_ACTION "UnitAction"
#define EPC_AD_SIGNAL_ACTION "SignalAction"
#define EPC_AD_SIGNAL_DEST "SignalDestination"
#define EPC_AD_SIGNAL_PATH "SignalPath"
#define EPC_AD_SIGNAL_INTERFACE "SignalInterface"
#define EPC_AD_SIGNAL_MEMBER "SignalMember"

int epc_fill_for_srv_restart(struct epc_object *obj, const char *service_path);

int epc_fill_for_srv_recover(struct epc_object *obj, const char *service_path, const char *recovery);

int epc_fill_for_unit_start(struct epc_object *obj, const char *unit_path);
int epc_fill_for_unit_action(struct epc_object *obj, const char *action);

int epc_fill_for_signal_forward(struct epc_object *obj, const char *dest,
				const char *objpath, const char *interface,
				const char *member);

#define epc_fill_for_reboot(o)					\
	epc_object_fill_empty(o)

#define epc_fill_for_recovery_reboot(o)		\
	epc_object_fill_empty(o)

#endif /* EPC_ACTION_H */
