/*
 * This file is part of activationd.
 *
 * Copyright © 2019 Samsung Electronics
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef EPC_CONFIG_H
#define EPC_CONFIG_H

struct epc_config {
	struct json_object *root;
};

void epc_get_modules_config(struct epc_config **c);
void epc_get_services_config(struct epc_config **c);
int epc_load_config(const char *custom_config_file);
void epc_config_cleanup(struct epc_config *c);
void epc_config_cleanup_global(void);
int epc_config_get_subconf(struct epc_config *conf, const char *key, struct epc_config **sub);

#endif /* EPC_CONFIG_H */
