/*
 * This file is part of activationd.
 *
 * Copyright © 2019 Samsung Electronics
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef EPC_SYSTEM_BOOTED_EVENT_H
#define EPC_SYSTEM_BOOTED_EVENT_H

#include <time.h>

#include "event.h"
#include "common.h"
#include "service.h"
#include "database.h"

#define SYSTEM_BOOTED_EVENT_ID "system_booted"
#define SB_EV_BID "bid"
#define SB_EV_PREV_BEV "p_bev"

struct system_booted_event {
	struct epc_event event;
	sd_id128_t boot_id;
	epc_oid_t prev_boot_event;
};

struct sb_event_data {
	sd_id128_t boot_id;
	epc_oid_t prev_boot_event;
};

#define to_system_booted_event(EVENT)						\
	container_of(EVENT, struct system_booted_event, event)

#endif /* EPC_SYSTEM_BOOTED_EVENT_H */
