#ifndef UNIT_CONTROL_H
#define UNIT_CONTROL_H

enum {
	UNIT_CONTROL_REQUEST_SENT = 0,
	UNIT_CONTROL_OK,
	UNIT_CONTROL_TIMEOUT,
	UNIT_CONTROL_ERROR,
};

typedef enum
{
	UNIT_CONTROL_BUS_TYPE_SYSTEM  = 1,
	UNIT_CONTROL_BUS_TYPE_SESSION = 2
} BusType;

enum {
	UNIT_CONTROL_TIMEOUT_DEFAULT = -1,
	UNIT_CONTROL_TIMEOUT_MAX = -2
} UnitControlTimeout;

typedef void (*actd_unit_cb)(int status, void *user_data);

int actd_start_unit(BusType bus_type, const char *unit, int timeout_ms);
int actd_stop_unit(BusType bus_type, const char *unit, int timeout_ms);
int actd_restart_unit(BusType bus_type, const char *unit, int timeout_ms);

int actd_start_unit_async(BusType bus_type, const char *unit, actd_unit_cb cb, void *user_data, int timeout_ms);
int actd_stop_unit_async(BusType bus_type, const char *unit, actd_unit_cb cb, void *user_data, int timeout_ms);
int actd_restart_unit_async(BusType bus_type, const char *unit, actd_unit_cb cb, void *user_data, int timeout_ms);

#endif /* UNIT_CONTROL_H */
