/*
 * This file is part of activationd.
 *
 * Copyright © 2019 Samsung Electronics
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef UNIT_CONTROL_EVENT_H
#define UNIT_CONTROL_EVENT_H

#include <time.h>
#include <gio/gio.h>
#include "event.h"

#define UC_EVENT_ID "unit_control"
#define UC_TIME "et"
#define UC_UNIT "unit"
#define UC_METHOD "method"

struct unit_control_event {
	struct epc_event event;
	GDBusMethodInvocation *m;
	int jobs_cnt;
	int err_code;
	char *method;
	char *unit;
	time_t event_time;
};

struct unit_control_event_data {
	GDBusMethodInvocation *m;
	int refs;
	int err_code;
	char *method;
	char *unit;
	time_t event_time;
};

#define to_unit_control_event(EVENT)						\
	container_of(EVENT, struct unit_control_event, event)


#endif /* UNIT_CONTROL_EVENT_H */
