Name:       activationd
Version:    0.2.0
Release:    0
License:    Apache-2.0
Source0:    %{name}-%{version}.tar.xz
Source1001: %{name}.manifest
Summary:    Event-based activation daemon
Group:      System/Monitoring
Requires:   event-processing-core
Requires:   event-processing-vconf
Requires:   event-processing-dbus
Requires:   event-processing-unit-control
Requires:   event-processing-activation-dm
Requires:   activationd-plugin
BuildRequires: pkgconfig(vconf)

%define with_activationd_glib_support 1

%description
Activationd allows starting systemd units based on various system events.

%package -n event-processing-core
Summary:       Event handling framework
BuildRequires: pkgconfig(libsystemd)
BuildRequires: pkgconfig(json-c)
%if %{with_activationd_glib_support}
BuildRequires: pkgconfig(glib-2.0)
BuildRequires: pkgconfig(libsyscommon)
%endif

%description -n event-processing-core
This package provides framework for handling system-wide events.

%package -n event-processing-extra
Summary:    activationd test services
Group:      System/Monitoring

%description -n event-processing-extra
Event processing extra modules

%package -n event-processing-vconf
Summary:    vconf listener module for epc
Group:      System/Monitoring
BuildRequires: pkgconfig(vconf)
Requires:   event-processing-core

%description -n event-processing-vconf
This package provides a listener for vconf events

%package -n event-processing-dbus
Summary:    dbus listener module for epc
Group:      System/Monitoring

%package -n event-processing-unit-control
Summary:    unit control dbus api module for epc
Group:      System/Monitoring
Requires:   event-processing-extra = %{version}

%description -n event-processing-unit-control
This package provides dbus api for unit control

%description -n event-processing-dbus
This package provides a listener for dbus events

%package -n event-processing-activation-dm
Summary:    Activation decision maker
Group:      System/Monitoring
Requires:   event-processing-core

%description -n event-processing-activation-dm
This package provides a decision maker for activating systemd units based on various system events

%package -n activationd-test-services
Summary:    activationd test services
Group:      System/Monitoring
BuildRequires: pkgconfig(vconf)
Requires:   event-processing-core

%description -n activationd-test-services
Services used to test activationd functionality

%package -n event-processing-devel
Summary:    epcd development files
Group:      System/Monitoring

%description  -n event-processing-devel
Files used in external modules development

%package -n libactd
Summary:    Activationd API
Group:      Development/Libraries
BuildRequires: pkgconfig(glib-2.0)
BuildRequires: pkgconfig(gio-2.0)
BuildRequires: pkgconfig(dlog)

%description -n libactd
This library provides API for interaction with modules

%package -n libactd-devel
Summary:    Activationd API development files
Group:      Development/Libraries
Requires:   libactd = %{version}

%description -n libactd-devel
This library provides development files needed for libactd.

%prep
%setup -q
cp %{SOURCE1001} .

%build
%autogen
%configure \
	--libdir=%{_libdir} \
	--enable-test-services \
%if %{with_activationd_glib_support}
	--enable-glib-mainloop \
%endif
	--enable-unit-tests \
	--enable-forced-reboot

make %{?_smp_mflags}

make check

%install
%make_install

mkdir -p %{buildroot}/%{_unitdir}/basic.target.wants
ln -s ../actd.service %{buildroot}/%{_unitdir}/basic.target.wants/actd.service

ln -s %{_sbindir}/actd %{buildroot}/%{_sbindir}/actdctl

%define moduledir %{_libdir}/actd/available-modules/
%define moduleconfdir %{_sysconfdir}/actd/available-modules/
%define enabled_moduledir %{_sysconfdir}/actd/enabled-modules/

mkdir -p %{buildroot}/%{moduledir}
mkdir -p %{buildroot}/%{moduleconfdir}
mkdir -p %{buildroot}/%{enabled_moduledir}

# install_module <module> <package>
%define install_module() \
	ln -s %{moduledir}/%1.so %{buildroot}/%{moduleconfdir}/%1.so; \
	ln -s ../available-modules/%1.so %{buildroot}/%{enabled_moduledir}/%1.so; \
	echo %{moduledir}/%1.so >> %2-files; \
	echo %{moduleconfdir}/%1.so >> %2-files; \
	echo %{enabled_moduledir}/%1.so >> %2-files;

%install_module service_restart_action extra
%install_module unit_start_action extra
%install_module forward_signal_action extra
%install_module vconf_key_changed_event vconf
%install_module vconf_listener vconf
%install_module dbus_signal_event dbus
%install_module dbus_listener dbus
%install_module unit_control_api unit-control
%install_module unit_control_event unit-control
%install_module unit_control_dm unit-control
%install_module activation_dm activation-dm

%files

%files -n libactd
%{_libdir}/libactd.so.*

%files -n libactd-devel
%{_libdir}/libactd.so
%{_libdir}/pkgconfig/libactd.pc
%{_includedir}/actd/*

%files -n event-processing-devel
%license COPYING
%{_libdir}/pkgconfig/epc.pc
%{_includedir}/epc/*

%files -n event-processing-activation-dm -f activation-dm-files
%license COPYING
%{_libdir}/actd/modules.conf.d/activation_eh.conf.d/50-default.conf

%files -n event-processing-vconf -f vconf-files
%{_libdir}/actd/modules.conf.d/vconf_listener.conf.d/50-default.conf

%files -n event-processing-dbus -f dbus-files
%{_libdir}/actd/modules.conf.d/dbus_listener.conf.d/50-default.conf

%files -n event-processing-unit-control -f unit-control-files
%license COPYING
%{_sysconfdir}/dbus-1/system.d/org.tizen.activationd.conf
%{_libdir}/actd/modules.conf.d/unit_control_eh.conf.d/50-default.conf

%files -n activationd-test-services
%license COPYING
%manifest %{name}.manifest
%{_bindir}/activationd_acceptance_service
%{_bindir}/activationd_acceptance_checker
%{_bindir}/activationd_acceptance_test
%{_bindir}/activationd_unit_tests
%{_unitdir_user}/activationd-acceptance-test-s-p.service
%{_unitdir}/activationd-acceptance-test-s-p.service
%{_unitdir}/activationd-acceptance-test-s-n.service
%{_unitdir}/activationd-acceptance-test-i-p.service
%{_unitdir}/activationd-acceptance-test-i-n.service
%{_unitdir}/activationd-acceptance-test-d-p.service
%{_unitdir}/activationd-acceptance-test-d-n.service
%{_unitdir}/activationd-acceptance-test-b-p.service
%{_unitdir}/activationd-acceptance-test-b-n.service
%{_libdir}/actd/modules.conf.d/vconf_listener.conf.d/99-acceptance-test.conf
%{_libdir}/actd/modules.conf.d/dbus_listener.conf.d/99-acceptance-test.conf
%{_libdir}/actd/modules.conf.d/activation_eh.conf.d/99-acceptance-test.conf
%{_libdir}/actd/modules.conf.d/unit_control_eh.conf.d/99-acceptance-test.conf

%files -n event-processing-core
%license COPYING
%manifest %{name}.manifest
%{_sbindir}/actd
%{_sbindir}/actdctl
%{_libdir}/actd/actd.conf
%{_unitdir}/actd.service
%{_unitdir}/basic.target.wants/actd.service
%dir %{_libdir}/actd/modules.conf.d

%files -n event-processing-extra -f extra-files

%docs_package
