/*
 * This file is part of activationd.
 *
 * Copyright © 2019 Samsung Electronics
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include "notify_queue.h"

#include <sys/eventfd.h>
#include <errno.h>

int init_notify_queue_head(struct nqueue_head *head)
{
	int ret;

	ret = eventfd(0, EFD_CLOEXEC | EFD_NONBLOCK | EFD_SEMAPHORE);
	if (ret < 0)
		return errno;

	INIT_QUEUE_HEAD(&head->qhead);
	head->fd = ret;

	return 0;
}

void cleanup_notify_queue_head(struct nqueue_head *head)
{
	close(head->fd);
	head->fd = -1;
}
