/*
 * This file is part of activationd.
 *
 * Copyright © 2019 Samsung Electronics
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <signal.h>

static void exit_handler(int signo)
{
	exit(EXIT_SUCCESS);
}

int main(int argc, char *argv[])
{
	if (signal(SIGINT, exit_handler) == SIG_ERR ||
			signal(SIGQUIT, exit_handler) == SIG_ERR ||
			signal(SIGTERM, exit_handler) == SIG_ERR) {
		perror("catching SIGNAL");
		exit(EXIT_FAILURE);
	}

	printf("service started, do nothing...\n");
	while (1)
		sleep(10);

	exit_handler(0);
}

